'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dockerParseImage = require('docker-parse-image');

var _dockerParseImage2 = _interopRequireDefault(_dockerParseImage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function ({
    getContainers,
    getBuilds
}) {
    return function manifestContainerBuilds(projectId, manifest) {
        const containers = getContainers(manifest);
        const builds = getBuilds(manifest);
        const accum = [];
        if (!builds) {
            return accum;
        }
        return containers.reduce((accum, { name, image }) => {
            const build = getBuild(builds, name);
            const parsedImage = (0, _dockerParseImage2.default)(image);
            const { registry, namespace, tag } = parsedImage;
            if (!(build && registry === 'gcr.io' && namespace === projectId && tag !== null && tag !== 'latest')) {
                return accum;
            }
            accum.push(_extends({
                image: parsedImage,
                build
            }, isCommitSha(tag) ? { commitSha: tag } : { tagName: tag }));
            return accum;
        }, accum);
    };
};

function isCommitSha(str) {
    try {
        return Buffer.from(str, 'hex').length === 20;
    } catch (e) {
        return false;
    }
}

function getBuild(builds, name) {
    return builds.filter(({ container }) => container === name)[0] || null;
}